/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMarca;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaMarcaController")
@Scope("prototype")
public class BusquedaMarcaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Marca> plwMarca;
    private MyListbox marcaList;
    private Paging pagingMarca;
    private Textbox txtNome;
    private Textbox txtEquivalencia;
    private Row rowEquivalencia;
    private Listheader headerEquivalencia;

    public MyListbox getMarcaList() {
        return marcaList;
    }

    public void setMarcaList(MyListbox marcaList) {
        this.marcaList = marcaList;
    }

    public Paging getPagingMarca() {
        return pagingMarca;
    }

    public void setPagingMarca(Paging pagingMarca) {
        this.pagingMarca = pagingMarca;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    public Listheader getHeaderEquivalencia() {
        return headerEquivalencia;
    }

    public void setHeaderEquivalencia(Listheader headerEquivalencia) {
        this.headerEquivalencia = headerEquivalencia;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        marcaList.setItemRenderer(new RenderMarca());
        marcaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Marca c = (Marca) marcaList.getSelected();
                verMarca(c);
            }
        });

        refreshLista();

        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
            headerEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    private void verMarca(Marca m) {
        if (m == null) {
            return;
        }

        Map args = new HashMap();
        args.put("busquedaMarcaController", this);
        args.put("marca", m);
        args.put("marcaList", marcaList);

        openWindow("/gui/catalogos/editarMarca.zul",
                Labels.getLabel("editarMarcaController.window.title"), args, MODAL);
    }

    public void refreshLista() {
        HibernateSearchObject<Marca> marcaBusqueda =
                new HibernateSearchObject<Marca>(Marca.class,
                pagingMarca.getPageSize());

        marcaBusqueda.addFilterLike("descmarca",
                "%" + txtNome.getText().trim().concat("%"));

        if (!txtEquivalencia.getText().isEmpty()) {
            marcaBusqueda.addFilterEqual("equivalenciaId", txtEquivalencia.getText());
        }

        marcaBusqueda.addSortAsc("descmarca");
        marcaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        marcaBusqueda.addFilterNotEqual("marcaId", -1);

        plwMarca.init(marcaBusqueda, marcaList, pagingMarca);

        if (marcaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaMarcaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verMarca(new Marca());
    }
}
